Index: code/branches/FICN/src/network/ConnectionManager.cc
===================================================================
--- code/branches/FICN/src/network/ConnectionManager.cc	(revision 774)
+++ code/branches/FICN/src/network/ConnectionManager.cc	(revision 777)
@@ -1,28 +1,28 @@
 /*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Oliver Scheuss, (C) 2007
- *   Co-authors:
- *      ...
- *
- */
+*   ORXONOX - the hottest 3D action shooter ever to exist
+*
+*
+*   License notice:
+*
+*   This program is free software; you can redistribute it and/or
+*   modify it under the terms of the GNU General Public License
+*   as published by the Free Software Foundation; either version 2
+*   of the License, or (at your option) any later version.
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*
+*   Author:
+*      Oliver Scheuss, (C) 2007
+*   Co-authors:
+*      ...
+*
+*/
 
 //
@@ -37,8 +37,16 @@
 //
 
+#include <iostream>
+// boost.thread library for multithreading support
+#include <boost/thread/thread.hpp>
+#include <boost/bind.hpp>
+
+#include "core/CoreIncludes.h"
+#include "ClientInformation.h"
 #include "ConnectionManager.h"
 
-namespace std{
-  bool operator< (ENetAddress a, ENetAddress b){
+namespace std
+{
+  bool operator< (ENetAddress a, ENetAddress b) {
     if(a.host <= b.host)
       return true;
@@ -48,9 +56,9 @@
 }
 
-namespace network{
-
+namespace network
+{
   boost::thread_group network_threads;
 
-  ConnectionManager::ConnectionManager(ClientInformation *head){
+  ConnectionManager::ConnectionManager(ClientInformation *head) {
     quit=false;
     bindAddress.host = ENET_HOST_ANY;
@@ -59,5 +67,5 @@
   }
 
-  ConnectionManager::ConnectionManager(int port, std::string address, ClientInformation *head){
+  ConnectionManager::ConnectionManager(int port, std::string address, ClientInformation *head) {
     quit=false;
     enet_address_set_host (& bindAddress, address.c_str());
@@ -66,5 +74,5 @@
   }
 
-  ConnectionManager::ConnectionManager(int port, const char *address, ClientInformation *head){
+  ConnectionManager::ConnectionManager(int port, const char *address, ClientInformation *head) {
     quit=false;
     enet_address_set_host (& bindAddress, address);
@@ -73,12 +81,12 @@
   }
 
-  ENetPacket *ConnectionManager::getPacket(ENetAddress &address){
+  ENetPacket *ConnectionManager::getPacket(ENetAddress &address) {
     if(!buffer.isEmpty())
       return buffer.pop(address);
     else
-        return NULL;
-  }
-
-  ENetPacket *ConnectionManager::getPacket(int &clientID){
+      return NULL;
+  }
+
+  ENetPacket *ConnectionManager::getPacket(int &clientID) {
     ENetAddress address;
     ENetPacket *packet=getPacket(address);
@@ -88,15 +96,15 @@
   }
 
-  bool ConnectionManager::queueEmpty(){
+  bool ConnectionManager::queueEmpty() {
     return buffer.isEmpty();
   }
 
-  void ConnectionManager::createListener(){
+  void ConnectionManager::createListener() {
     network_threads.create_thread(boost::bind(boost::mem_fn(&ConnectionManager::receiverThread), this));
-//     boost::thread thr(boost::bind(boost::mem_fn(&ConnectionManager::receiverThread), this));
+    //     boost::thread thr(boost::bind(boost::mem_fn(&ConnectionManager::receiverThread), this));
     return;
   }
 
-  bool ConnectionManager::quitListener(){
+  bool ConnectionManager::quitListener() {
     quit=true;
     network_threads.join_all();
@@ -104,5 +112,5 @@
   }
 
-  bool ConnectionManager::addPacket(ENetPacket *packet, ENetPeer *peer){
+  bool ConnectionManager::addPacket(ENetPacket *packet, ENetPeer *peer) {
     if(enet_peer_send(peer, head_->findClient(&(peer->address))->getID() , packet)!=0)
       return false;
@@ -110,5 +118,5 @@
   }
 
-  bool ConnectionManager::addPacket(ENetPacket *packet, int clientID){
+  bool ConnectionManager::addPacket(ENetPacket *packet, int clientID) {
     if(enet_peer_send(head_->findClient(clientID)->getPeer(), clientID, packet)!=0)
       return false;
@@ -116,13 +124,13 @@
   }
 
-  bool ConnectionManager::addPacketAll(ENetPacket *packet){
+  bool ConnectionManager::addPacketAll(ENetPacket *packet) {
     for(ClientInformation *i=head_->next(); i!=0; i=i->next()){
       if(enet_peer_send(i->getPeer(), i->getID(), packet)!=0)
-         return false;
-    }
-    return true;
-  }
-
-  bool ConnectionManager::sendPackets(ENetEvent *event){
+        return false;
+    }
+    return true;
+  }
+
+  bool ConnectionManager::sendPackets(ENetEvent *event) {
     if(server==NULL)
       return false;
@@ -133,5 +141,5 @@
   }
 
-  bool ConnectionManager::sendPackets(){
+  bool ConnectionManager::sendPackets() {
     ENetEvent event;
     if(server==NULL)
@@ -143,5 +151,5 @@
   }
 
-  void ConnectionManager::receiverThread(){
+  void ConnectionManager::receiverThread() {
     // what about some error-handling here ?
     enet_initialize();
@@ -164,16 +172,16 @@
         // log handling ================
         case ENET_EVENT_TYPE_CONNECT:
-        addClient(&event);
-        break;
-      case ENET_EVENT_TYPE_RECEIVE:
-        //std::cout << "received data" << std::endl;
-        processData(&event);
-        break;
-      case ENET_EVENT_TYPE_DISCONNECT:
-        // add some error/log handling here
-        clientDisconnect(event.peer);
-        break;
-      case ENET_EVENT_TYPE_NONE:
-        break;
+          addClient(&event);
+          break;
+        case ENET_EVENT_TYPE_RECEIVE:
+          //std::cout << "received data" << std::endl;
+          processData(&event);
+          break;
+        case ENET_EVENT_TYPE_DISCONNECT:
+          // add some error/log handling here
+          clientDisconnect(event.peer);
+          break;
+        case ENET_EVENT_TYPE_NONE:
+          break;
       }
     }
@@ -183,5 +191,5 @@
   }
 
-  void ConnectionManager::disconnectClients(){
+  void ConnectionManager::disconnectClients() {
     ENetEvent event;
     ClientInformation *temp = head_->next();
@@ -194,14 +202,14 @@
       switch (event.type)
       {
-        case ENET_EVENT_TYPE_NONE:
-        case ENET_EVENT_TYPE_CONNECT:
-        case ENET_EVENT_TYPE_RECEIVE:
-          enet_packet_destroy(event.packet);
-          break;
-        case ENET_EVENT_TYPE_DISCONNECT:
-          std::cout << "disconnecting client" << std::endl;
-          delete head_->findClient(&(event.peer->address));
-          temp = temp->next();
-          break;
+      case ENET_EVENT_TYPE_NONE:
+      case ENET_EVENT_TYPE_CONNECT:
+      case ENET_EVENT_TYPE_RECEIVE:
+        enet_packet_destroy(event.packet);
+        break;
+      case ENET_EVENT_TYPE_DISCONNECT:
+        std::cout << "disconnecting client" << std::endl;
+        delete head_->findClient(&(event.peer->address));
+        temp = temp->next();
+        break;
       }
     }
@@ -209,5 +217,5 @@
   }
 
-  bool ConnectionManager::processData(ENetEvent *event){
+  bool ConnectionManager::processData(ENetEvent *event) {
     // just add packet to the buffer
     // this can be extended with some preprocessing
@@ -215,15 +223,13 @@
   }
 
-//   bool ConnectionManager::clientDisconnect(ENetPeer *peer){
-//     return clientDisconnect(*peer);
-//   }
-
-
-
-  bool ConnectionManager::clientDisconnect(ENetPeer *peer){
+  //bool ConnectionManager::clientDisconnect(ENetPeer *peer) {
+  //  return clientDisconnect(*peer);
+  //}
+
+  bool ConnectionManager::clientDisconnect(ENetPeer *peer) {
     return head_->removeClient(peer);
   }
 
-  bool ConnectionManager::addClient(ENetEvent *event){
+  bool ConnectionManager::addClient(ENetEvent *event) {
     ClientInformation *temp = head_->insertBack(new ClientInformation);
     if(temp->prev()->head)
@@ -238,17 +244,17 @@
   }
 
-  int ConnectionManager::getClientID(ENetPeer peer){
+  int ConnectionManager::getClientID(ENetPeer peer) {
     return getClientID(peer.address);
   }
 
-  int ConnectionManager::getClientID(ENetAddress address){
+  int ConnectionManager::getClientID(ENetAddress address) {
     return head_->findClient(&address)->getID();
   }
 
-  ENetPeer *ConnectionManager::getClientPeer(int clientID){
+  ENetPeer *ConnectionManager::getClientPeer(int clientID) {
     return head_->findClient(clientID)->getPeer();
   }
 
-  void ConnectionManager::syncClassid(int clientID){
+  void ConnectionManager::syncClassid(int clientID) {
     int i=0;
     std::string classname;
Index: code/branches/FICN/src/network/ConnectionManager.h
===================================================================
--- code/branches/FICN/src/network/ConnectionManager.h	(revision 774)
+++ code/branches/FICN/src/network/ConnectionManager.h	(revision 777)
@@ -13,23 +13,19 @@
 #define _ConnectionManager_H__
 
-#include <iostream>
 #include <string>
 // enet library for networking support
 #include <enet/enet.h>
-// boost.thread library for multithreading support
-#include <boost/thread/thread.hpp>
-#include <boost/bind.hpp>
-// headerfiles
-#include "ClientInformation.h"
+
+#include "NetworkPrereqs.h"
 #include "PacketBuffer.h"
 #include "PacketManager.h"
-#include "core/CoreIncludes.h"
 
-namespace std{
+namespace std
+{
   bool operator<(ENetAddress a, ENetAddress b);
 }
 
-namespace network{
-  //
+namespace network
+{
 #define NETWORK_PORT 55556
 #define NETWORK_MAX_CONNECTIONS 50
@@ -42,7 +38,7 @@
     ClientList *next;
   };
-  
+
   class ConnectionManager{
-    public:
+  public:
     ConnectionManager(ClientInformation *head);
     ConnectionManager(int port, const char *address, ClientInformation *head);
@@ -71,8 +67,8 @@
     PacketBuffer buffer;
     PacketGenerator packet_gen;
-    
+
     ENetHost *server;
     ENetAddress bindAddress;
-    
+
     bool quit; // quit-variable (communication with threads)
     ClientInformation *head_;
Index: code/branches/FICN/src/network/GameStateClient.cc
===================================================================
--- code/branches/FICN/src/network/GameStateClient.cc	(revision 774)
+++ code/branches/FICN/src/network/GameStateClient.cc	(revision 777)
@@ -1,189 +1,183 @@
 /*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      ...
- *   Co-authors:
- *      ...
- *
- */
+*   ORXONOX - the hottest 3D action shooter ever to exist
+*
+*
+*   License notice:
+*
+*   This program is free software; you can redistribute it and/or
+*   modify it under the terms of the GNU General Public License
+*   as published by the Free Software Foundation; either version 2
+*   of the License, or (at your option) any later version.
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*
+*   Author:
+*      ...
+*   Co-authors:
+*      ...
+*
+*/
+#include <zlib.h>
 
+#include "core/CoreIncludes.h"
+#include "Synchronisable.h"
 #include "GameStateClient.h"
 
-namespace network {
-
-GameStateClient::GameStateClient()
+namespace network
 {
-}
-
-
-GameStateClient::~GameStateClient()
-{
-}
-
-bool GameStateClient::pushGameState(GameStateCompressed *compstate){
-  if(compstate->diffed)
-    return loadSnapshot(decode(reference, *compstate));
-  else
-    return loadSnapshot(decode(*compstate));
-}
-
-
-/**
- * This function removes a Synchronisable out of the universe
- * @param it iterator of the list pointing to the object
- * @return iterator pointing to the next object in the list
- */
-void GameStateClient::removeObject(orxonox::Iterator<Synchronisable> &it){
-  orxonox::Iterator<Synchronisable> temp=it;
-  ++it;
-  delete  *temp;
-}
-
-/**
- * This function loads a Snapshort of the gamestate into the universe
- * @param state a GameState struct containing the size of the gamestate and a pointer linking to a flat list (returned by getSnapshot)
- */
-bool GameStateClient::loadSnapshot(GameState state)
-{
-  unsigned char *data=state.data;
-  std::cout << "loadSnapshot: loading gs: " << state.id << std::endl;
-  // get the start of the Synchronisable list
-  orxonox::Iterator<Synchronisable> it=orxonox::ObjectList<Synchronisable>::start();
-  syncData sync;
-  // loop as long as we have some data ;)
-  while(data < state.data+state.size){
-    // prepare the syncData struct
-    sync.length = (int)*data;
-    data+=sizeof(int);
-    sync.objectID = (int)*data;
-    data+=sizeof(int);
-    sync.classID = (int)*data;
-    data+=sizeof(int);
-    sync.data = data;
-    data+=sync.length;
-
-    if(it->objectID!=sync.objectID){
-      // bad luck ;)
-      // delete the synchronisable (obviously seems to be deleted on the server)
-      while(it != 0 && it->objectID!=sync.objectID){
-        removeObject(it);
-      }
-      if(it==0){
-        std::cout << "classid: " << sync.classID << ", name: " << ID(sync.classID)->getName() << std::endl;
-        orxonox::BaseObject *no = ID(sync.classID)->fabricate();
-        ((Synchronisable *)no)->objectID=sync.objectID;
-        ((Synchronisable *)no)->classID=sync.classID;
-        it=orxonox::ObjectList<Synchronisable>::end();
-        // update data and create object/entity...
-        if( !(((Synchronisable *)no)->updateData(sync)) && !(((Synchronisable *)no)->create()) )
-          COUT(0) << "We couldn't create/update the object: " << sync.objectID << std::endl;
-        ++it;
-      }
-    } else {
-      // we have our object
-      if(! it->updateData(sync))
-        std::cout << "We couldn't update objectID: " \
-            << sync.objectID << "; classID: " << sync.classID << std::endl;
-    }
-    ++it;
+  GameStateClient::GameStateClient() {
   }
 
-  return true;
-}
+  GameStateClient::~GameStateClient() {
+  }
 
-GameState GameStateClient::diff(GameState a, GameState b){
-  unsigned char *ap = a.data, *bp = b.data;
-  int of=0; // pointers offset
-  int dest_length=0;
-  if(a.size>=b.size)
-    dest_length=a.size;
-  else
-    dest_length=b.size;
-  unsigned char *dp = (unsigned char *)malloc(dest_length*sizeof(unsigned char));
-  while(of<a.size && of<b.size){
-    *(dp+of)=*(ap+of)^*(bp+of); // do the xor
-    ++of;
+  bool GameStateClient::pushGameState(GameStateCompressed *compstate) {
+    if(compstate->diffed)
+      return loadSnapshot(decode(reference, *compstate));
+    else
+      return loadSnapshot(decode(*compstate));
   }
-  if(a.size!=b.size){ // do we have to fill up ?
-    unsigned char n=0;
-    if(a.size<b.size){
-      while(of<dest_length){
-        *(dp+of)=n^*(bp+of);
-        of++;
+
+  /**
+  * This function removes a Synchronisable out of the universe
+  * @param it iterator of the list pointing to the object
+  * @return iterator pointing to the next object in the list
+  */
+  void GameStateClient::removeObject(orxonox::Iterator<Synchronisable> &it) {
+    orxonox::Iterator<Synchronisable> temp=it;
+    ++it;
+    delete  *temp;
+  }
+
+  /**
+  * This function loads a Snapshort of the gamestate into the universe
+  * @param state a GameState struct containing the size of the gamestate and a pointer linking to a flat list (returned by getSnapshot)
+  */
+  bool GameStateClient::loadSnapshot(GameState state) {
+    unsigned char *data=state.data;
+    std::cout << "loadSnapshot: loading gs: " << state.id << std::endl;
+    // get the start of the Synchronisable list
+    orxonox::Iterator<Synchronisable> it=orxonox::ObjectList<Synchronisable>::start();
+    syncData sync;
+    // loop as long as we have some data ;)
+    while(data < state.data+state.size){
+      // prepare the syncData struct
+      sync.length = (int)*data;
+      data+=sizeof(int);
+      sync.objectID = (int)*data;
+      data+=sizeof(int);
+      sync.classID = (int)*data;
+      data+=sizeof(int);
+      sync.data = data;
+      data+=sync.length;
+
+      if(it->objectID!=sync.objectID){
+        // bad luck ;)
+        // delete the synchronisable (obviously seems to be deleted on the server)
+        while(it != 0 && it->objectID!=sync.objectID){
+          removeObject(it);
+        }
+        if(it==0){
+          std::cout << "classid: " << sync.classID << ", name: " << ID(sync.classID)->getName() << std::endl;
+          Synchronisable *no = (Synchronisable*)(ID(sync.classID)->fabricate());
+          no->objectID=sync.objectID;
+          no->classID=sync.classID;
+          it=orxonox::ObjectList<Synchronisable>::end();
+          // update data and create object/entity...
+          if( !no->updateData(sync) && !no->create() )
+            COUT(0) << "We couldn't create/update the object: " << sync.objectID << std::endl;
+          ++it;
+        }
+      } else {
+        // we have our object
+        if(! it->updateData(sync))
+          std::cout << "We couldn't update objectID: " \
+          << sync.objectID << "; classID: " << sync.classID << std::endl;
       }
-    } else{
-      while(of<dest_length){
-        *(dp+of)=*(ap+of)^n;
-        of++;
+      ++it;
+    }
+
+    return true;
+  }
+
+  GameState GameStateClient::diff(GameState a, GameState b) {
+    unsigned char *ap = a.data, *bp = b.data;
+    int of=0; // pointers offset
+    int dest_length=0;
+    if(a.size>=b.size)
+      dest_length=a.size;
+    else
+      dest_length=b.size;
+    unsigned char *dp = (unsigned char *)malloc(dest_length*sizeof(unsigned char));
+    while(of<a.size && of<b.size){
+      *(dp+of)=*(ap+of)^*(bp+of); // do the xor
+      ++of;
+    }
+    if(a.size!=b.size){ // do we have to fill up ?
+      unsigned char n=0;
+      if(a.size<b.size){
+        while(of<dest_length){
+          *(dp+of)=n^*(bp+of);
+          of++;
+        }
+      } else{
+        while(of<dest_length){
+          *(dp+of)=*(ap+of)^n;
+          of++;
+        }
       }
     }
-  }
-  // should be finished now
-  GameState r = {b.id, dest_length, dp};
-  return r;
-}
-
-
-GameState GameStateClient::decompress(GameStateCompressed a){
-  int normsize = a.normsize;
-  int compsize = a.compsize;
-  int bufsize;
-  if(normsize < compsize)
-    bufsize = compsize;
-  else
-    bufsize = normsize;
-  unsigned char* dest = (unsigned char*)malloc( bufsize );
-  int retval;
-  uLongf length=normsize;
-  //std::cout << "gamestateclient" << std::endl;
-  //std::cout << "normsize " << a.normsize << " compsize " << a.compsize << " " << bufsize << std::endl;
-  retval = uncompress( dest, &length, a.data, (uLong)compsize );
-  //std::cout << "length " << length << std::endl;
-  switch ( retval ) {
-    case Z_OK: std::cout << "successfully decompressed" << std::endl; break;
-    case Z_MEM_ERROR: std::cout << "not enough memory available" << std::endl; break;
-    case Z_BUF_ERROR: std::cout << "not enough memory available in the buffer" << std::endl; break;
-    case Z_DATA_ERROR: std::cout << "data corrupted" << std::endl; break;
+    // should be finished now
+    GameState r = {b.id, dest_length, dp};
+    return r;
   }
 
-  GameState gamestate;
-  gamestate.id = a.id;
-  gamestate.size = normsize;
-  gamestate.data = dest;
-  gamestate.diffed = a.diffed;
-  
-  return gamestate;
-}
+  GameState GameStateClient::decompress(GameStateCompressed a) {
+    int normsize = a.normsize;
+    int compsize = a.compsize;
+    int bufsize;
+    if(normsize < compsize)
+      bufsize = compsize;
+    else
+      bufsize = normsize;
+    unsigned char* dest = (unsigned char*)malloc( bufsize );
+    int retval;
+    uLongf length=normsize;
+    //std::cout << "gamestateclient" << std::endl;
+    //std::cout << "normsize " << a.normsize << " compsize " << a.compsize << " " << bufsize << std::endl;
+    retval = uncompress( dest, &length, a.data, (uLong)compsize );
+    //std::cout << "length " << length << std::endl;
+    switch ( retval ) {
+      case Z_OK: std::cout << "successfully decompressed" << std::endl; break;
+      case Z_MEM_ERROR: std::cout << "not enough memory available" << std::endl; break;
+      case Z_BUF_ERROR: std::cout << "not enough memory available in the buffer" << std::endl; break;
+      case Z_DATA_ERROR: std::cout << "data corrupted" << std::endl; break;
+    }
 
+    GameState gamestate;
+    gamestate.id = a.id;
+    gamestate.size = normsize;
+    gamestate.data = dest;
+    gamestate.diffed = a.diffed;
 
-GameState GameStateClient::decode(GameState a, GameStateCompressed x){
-  GameState t = decompress(x);
-  return diff(a, t);
-}
+    return gamestate;
+  }
 
-GameState GameStateClient::decode(GameStateCompressed x){
-  GameState t = decompress(x);
-  return t;
-}
+  GameState GameStateClient::decode(GameState a, GameStateCompressed x) {
+    GameState t = decompress(x);
+    return diff(a, t);
+  }
 
-
+  GameState GameStateClient::decode(GameStateCompressed x) {
+    GameState t = decompress(x);
+    return t;
+  }
 
 }
Index: code/branches/FICN/src/network/GameStateClient.h
===================================================================
--- code/branches/FICN/src/network/GameStateClient.h	(revision 774)
+++ code/branches/FICN/src/network/GameStateClient.h	(revision 777)
@@ -13,27 +13,25 @@
 #define _GameStateClient_H__
 
-#include "zlib.h"
-#include "Synchronisable.h"
-#include "core/CoreIncludes.h"
-#include "core/BaseObject.h"
+#include "NetworkPrereqs.h"
 #include "GameStateManager.h"
 
-namespace network {
+namespace network
+{
+  class GameStateClient
+  {
+  public:
+    GameStateClient();
+    ~GameStateClient();
+    bool pushGameState(GameStateCompressed *compstate);
+  private:
+    bool loadSnapshot(GameState state);
+    GameState diff(GameState a, GameState b);
+    GameState decompress(GameStateCompressed a);
+    GameState decode(GameState a, GameStateCompressed x);
+    GameState decode(GameStateCompressed x);
+    void removeObject(orxonox::Iterator<Synchronisable> &it);
 
-class GameStateClient{
-public:
-  GameStateClient();
-  ~GameStateClient();
-  bool pushGameState(GameStateCompressed *compstate);
-private:
-  bool loadSnapshot(GameState state);
-  GameState diff(GameState a, GameState b);
-  GameState decompress(GameStateCompressed a);
-  GameState decode(GameState a, GameStateCompressed x);
-  GameState decode(GameStateCompressed x);
-  void removeObject(orxonox::Iterator<Synchronisable> &it);
-
-  GameState reference;
-};
+    GameState reference;
+  };
 
 }
